/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
/**
spooler.h enthlt alles was man brauch. Dieser Header ist vorkompiliert.
*/
#include "spooler.h"
//#include "../zschimmer/file.h"
#include "schema_reader.h"


using namespace zschimmer;

namespace sos
{
	namespace scheduler
	{
		namespace file 
		{
			/**
			* \file schema_reader.cxx
			* \brief Allgemeine Funktionen fr Scheduler Files (XSD-Schema, ini, ...)
			* \detail
			*
			* \author RB/SS
			* \version 2.0.224 - 2010-02-16 16:06
			* <div class="sos_branding">
			*    <p> 2010 SOS GmbH - Berlin (<a style="color:silver" href="http://www.sos-berlin.com">http://www.sos-berlin.com</a>)</p>
			* </div>
			*/

			/**
			* \brief Einlesen des XSD-Schemas in lokale Variable
			* \detail
			* Bisher wurde das XSD-Schema als Literal in ein C++Modul abgelegt und kompiliert.
			* nderungen am XSD-Schema haben damit keinen Einflu auf den Scheduler.
			* Diese Funktion liest das Schema dynamisch ein und stellt es als string zur Verfgung.
			*
			* \version 2.0.224 - 2010-02-16 16:06
			*
			* \param filename - Vollstndiger Dateiname 
			* \return string
			*/
			string xsd_from_file( const string& filename )
			{ 
				return string_from_file( filename );

			}

		}
	}
}
